OneWire  ds(A6);
int celsius;
loop - 

//шукаємо адресу датчика для змінної addr
  if ( !ds.search(addr))
  {
    ds.reset_search();
    return;  //вихід з циклу НЕЗАЛЕЖНО від отриманого значення
  }

  //перевірка відсутності помилок та шумів за рахунок циклічної надлишковості даних
  if (OneWire::crc8(addr, 7) != addr[7]) {
    //Serial.println("CRC is not valid!");  //при помилці виводимо повідомлення в ПК
    return; //вихід з циклу НЕЗАЛЕЖНО від отриманого значення
  }
  // визначаємо серію датчика
  switch (addr[0])
  {
    case 0x10:
      type_s = 1;
      break;
    case 0x28:
      type_s = 0;
      break;
    case 0x22:
      type_s = 0;
      break;
    default:
      return;
  }

  ds.reset();  // скидання значень шини даних
  ds.select(addr);  // вибираємо унікальну адресу датчика
  ds.write(0x44, 1);  // проводимо заміри в режимі паразитного живлення(тим не менше, датчик підключити з "підтяжкою" в звичайному(!) режимі)
  delay(t); //затримка проведення замірів з датчика на час t

  ds.reset();  //скидання значень шини даних
  ds.select(addr);  //вибираємо унікальну адресу датчика
  ds.write(0xBE);  // зчитуємо оперативну пам'ять датчика

  for ( i = 0; i < 9; i++) {
    data[i] = ds.read();  //заповнюємо масив зчитаними даними
  }
  // дані температури - перші 2 байти, зчитуємо їх, об'єднуємо та переводимо в шістнадцяткове число
  int16_t raw = (data[1] << 8) | data[0];  //Переводимо температуру в значення за Цельсієм та Фаренгейтом
  if (type_s) {
    raw = raw << 3;  //за умовчанням - роздільна здатність 9 біт
    if (data[7] == 0x10) {
      // "пропуск обчислення значення" дає повнороздільне значення 12 біт(НЕ змінювати - призводить до краху програми)
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } else {  //інакше
    byte cfg = (data[4] & 0x60);
    // при малій роздільній здатності молодший біт не визначається і "зануляється"
    if (cfg == 0x00) raw = raw & ~7;  // роздільна здатність 9 біт, 93.75 мс
    else if (cfg == 0x20) raw = raw & ~3; // роздільна здатність 10 bit, 187.5 мс
    else if (cfg == 0x40) raw = raw & ~1; // роздільна здатність 11 bit, 375 мс
    //// за умовчанням роздільна здатність 12 біт, час конвертації 750 мс
  }
  celsius =  (float)raw / 16.0;  //обчислення температури за Цельсієм